﻿using UnityEngine;
using System.Collections;

public class CameraFollow : MonoBehaviour
{
	public GameObject objectToFollow;
	public bool scrolling = false;
	public float initialSpeed = 1;
	public float speed = 1;

	public bool follow = true;
	public bool playerCanGoUp = true;

	public Transform backgroundToWalk;
	public float backgroundMinY;
	public float backgroundStep;

	private float? lastY = null;

	void Update ()
	{
		if (follow != true)
			return;

		Vector3 newPosition = transform.position;
		Vector3 backgroundNewPosition = new Vector3 ();;

		if (backgroundToWalk != null)
			backgroundNewPosition = backgroundToWalk.localPosition;

		if (newPosition.y < objectToFollow.transform.position.y && !playerCanGoUp)
		{
			newPosition.y = objectToFollow.transform.position.y;

			if (backgroundToWalk != null && backgroundToWalk.localPosition.y > maxBackgroundMovement())
				backgroundNewPosition.y -= backgroundStep;
		}
		else if (newPosition.y == lastY && scrolling)
		{
			newPosition.y += (initialSpeed / 100) + ((Mathf.Abs(transform.position.y) / 1000) * speed);

			if (backgroundToWalk != null && backgroundToWalk.localPosition.y > maxBackgroundMovement())
				backgroundNewPosition.y -= backgroundStep;
		}

		transform.position = newPosition;

		if (backgroundToWalk != null)
			backgroundToWalk.localPosition = backgroundNewPosition;

		lastY = newPosition.y;
	}

	public float maxBackgroundMovement ()
	{
		return backgroundMinY;
	}
}
