﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class ObjectOverlay : MonoBehaviour
{
	public Color overlayColor;
	public List<GameObject> overlayObjects;

	private Color originalColor;

	public void OnTriggerEnter(Collider collisionInfo)
	{
		if (!overlayObjects.Contains (collisionInfo.gameObject) )
			return;

		mySprite.color = overlayColor;
	}

	public void OnTriggerExit(Collider collisionInfo)
	{
		if (!overlayObjects.Contains (collisionInfo.gameObject))
			return;

		mySprite.color = originalColor;
	}

	private SpriteRenderer mySprite
	{
		get
		{
			return GetComponent<SpriteRenderer>();
		}
	}
	
	public void Start ()
	{
		originalColor = mySprite.color;
	}
}
