﻿using UnityEngine;
using System.Collections;

public class TupaManager : MonoBehaviour 
{
	public HoppingManager manager;
	public bool jumping = false;
	public bool canJump = false;
	public float jumpForce = 10f;
	private float fixedZ;
	public bool untouched = true;

	public CameraFollow cameraFollow;

	public int score;

	public void Start ()
	{
		fixedZ = transform.position.z;
	}

	public IEnumerator Jump()
	{
		if(!canJump || jumping)
			yield break;

		jumping = true;
		RealyJump();
//		GetComponent<Animator> ().SetBool ("jumping", true);
	}

	public void RealyJump ()
	{
		rigidbody.velocity = Vector3.zero;
		rigidbody.AddForce(Vector3.up * jumpForce);

		gameObject.transform.parent = null;
		
		cameraFollow.follow = true;
	}

	public void OnTriggerEnter(Collider collision)
	{
		Debug.Log (collision.gameObject.tag);

		if (collision.gameObject.tag == "water") 
		{
			score++;
			Destroy(collision.gameObject);
			return;
		}
		if (collision.gameObject.tag == "rads") 
		{
			score--;
			Destroy(collision.gameObject);
			return;
		}
						

		if(collision.gameObject.name == "SideLimits")
			return;

		transform.parent = collision.gameObject.transform;
		////Debug.Log("Acertou!");
		if(
			collision.transform.parent.gameObject.GetComponent<PlatformManager>() != null
			&& collision.transform.parent.gameObject.GetComponent<PlatformManager>().untouched
		)
		{
			collision.transform.parent.gameObject.GetComponent<PlatformManager>().untouched = false;
		}

		if(jumping)
		{
			jumping = false;
			CanJump();
//			GetComponent<Animator>().SetBool("jumping", false);
		}
	}

	public void CanJump ()
	{
		canJump = true;
	}
	
	public void OnCollisionExit(Collision col)
	{
		if(jumping)
			canJump = false;
		else
			canJump = true;
	}

	void Update()
	{
		if (score >= 10) 
		{
			Application.LoadLevel("Instructions_Min2");
		}
		if(Input.GetKeyDown(KeyCode.Space))
		{
			if(!jumping)
				StartCoroutine("Jump");
		}

		if(Input.GetKey("left"))
		{
			if((transform.position.x - 0.05f) > -3f && !jumping)
			{
				transform.position = new Vector3(
					(transform.position.x - 0.05f),
					transform.position.y,
					fixedZ
					);
			}
		}

		if(Input.GetKey("right"))
		{
			if((transform.position.x + 0.05f) < 3f && !jumping)
			{
				transform.position = new Vector3(
					(transform.position.x + 0.05f),
					transform.position.y,
					fixedZ
					);
			}
		}

		transform.position = new Vector3(
			transform.position.x,
			transform.position.y,
			fixedZ
		);
	}
}
