﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(AudioSource))]
public class CityController : MonoBehaviour {

	public enum stateCity{
		NORMAL,
		HOT,
		BURN,
		INFERNO,
		NULL
	}

	private stateCity currentState = stateCity.NORMAL;
	private stateCity lastState = stateCity.NULL;
	public GameObject playerController;

	//variaveis para troca do sprite
	public Sprite city01;
	public Sprite city02;
	public Sprite city03;
	public Sprite city04;

	private bool normal = false;
	private bool hot = false;
	private bool burn= false;
	private bool inferno = false;

	private SpriteRenderer spriteRender;

	//variavel do tempo pra queimar... MUAHAHAHA
	public float timeToHot = 30.0f;
	public float timeToBurn = 60.0f;
	public float timeToInferno = 90.0f;
	public float currentTimeToBurn;

	//variaveis do poder da chuva
	//Isso esta pessimo... Pensar melhor nisso quando nao estiver com sono...i can get nooooo
	public float rainDuration = 5;
	public float rain = 5;
	public float currentRainDuration;

	//relacionado a mudanca da nuvem
	public GameObject rainCloud;
	public GameObject thunderCloud;
	public bool isRaining = false;
	public AudioClip heavyRain;
	public AudioClip lightRain;
	public AudioClip lightning;



	//public int water;

	void Start()
	{

		playerController = GameObject.FindGameObjectWithTag ("playerController");
		spriteRender = GetComponent<SpriteRenderer> ();
		if (spriteRender == null)
						spriteRender.sprite = city01;

	}
	public void SwitchState(stateCity nextState)
	{
		lastState = currentState;
		currentState = nextState;	
	}

	void Update()
	{
		CityStateMachine ();

		if (isRaining)
		{

			audio.PlayOneShot(lightRain);
			currentRainDuration += Time.deltaTime;
			if(currentRainDuration > rain)
			{
				//q horror!!!!
				currentRainDuration = 0;
				isRaining = false;
				thunderCloud.SetActive(false);
				rainCloud.SetActive(false);
			}
		}
	}

	void OnMouseDown()
	{

		if (playerController.GetComponent<PlayerController>().waterShoots > 0) 
		{
			if(isRaining)
			{
				thunderCloud.SetActive(true);
				rainCloud.SetActive(false);
				currentTimeToBurn = currentTimeToBurn - (rain * 1.2f) ;


			}
			else
			{
				rainCloud.SetActive(true);
				thunderCloud.SetActive(false); 
				currentTimeToBurn = currentTimeToBurn - rain;
				isRaining = true;
			}


			playerController.GetComponent<PlayerController>().waterShoots--;

			if (playerController.GetComponent<PlayerController> ().waterShoots == 0) 
			{
				Debug.Log("acabou a municao");
				
			}
		}


	}

	void CityStateMachine()
	{
		switch (currentState) 
		{
		case stateCity.NORMAL:
		{
			spriteRender.sprite = city01;
			currentTimeToBurn += Time.deltaTime;
			if(currentTimeToBurn > timeToHot)
			{
				//currentTimeToBurn = 0;
				SwitchState(stateCity.HOT);
			}

		}
		break;
		case stateCity.HOT:
		{
			spriteRender.sprite = city02;
			currentTimeToBurn += Time.deltaTime;
			if(currentTimeToBurn > timeToBurn)
			{
				//currentTimeToBurn = 0;
				SwitchState(stateCity.BURN);
			}
			else if(currentTimeToBurn < timeToHot)
			{
				//currentTimeToBurn = 0;
				SwitchState(stateCity.NORMAL);
			}
		}
			break;
		case stateCity.BURN:
		{
			spriteRender.sprite = city03;
			currentTimeToBurn += Time.deltaTime;
			if(currentTimeToBurn > timeToInferno)
			{
				//currentTimeToBurn = 0;
				SwitchState(stateCity.INFERNO);
			}
			else if(currentTimeToBurn < timeToBurn)
			{
				//currentTimeToBurn = 0;
				SwitchState(stateCity.HOT);
			}

		}
			break;
		case stateCity.INFERNO:
		{
			spriteRender.sprite = city04;
			if(currentTimeToBurn < timeToInferno)
			{
				//currentTimeToBurn = 0;
				SwitchState(stateCity.BURN);
			}
		}
			break;
		case stateCity.NULL:
		{
			
		}
			break;
		}
	}
	

}
